function [P,L,U]=PALU(A)
% permuted LU factorization
%   P*A=L*U
  m=size(A,1);
  assert(size(A,2)==m)
  L=eye(m,m);
  P=eye(m,m);
  U=A;
  for i=1:m-1
    [~,idx]=max(abs(U(i:end,i)));
    mu=idx(1)+i-1;
    if abs(U(mu,i))> 1e-15
      if i~=mu
        U([i,mu],i:end)=U([mu,i],i:end);
        L([i,mu],1:i-1)=L([mu,i],1:i-1);
        P([i,mu],:)=P([mu,i],:);
      end
      for j=i+1:m
        L(j,i)=U(j,i)/U(i,i);
        U(j,i:end)=U(j,i:end)-L(j,i)*U(i,i:end);
      end
    end
  end
end
