function X=tril_Cpt(A,B)
% A : N-by-d-by-d, N  d-by-d regular lower triangular matrices
  assert(fc_linalg3D.is3Darray(A));
  [N,m,n]=size(A);
  [dimA,dimB]=fc_linalg3D.getDimensions(A,B);
  assert( dimA(2)==dimA(3) && dimA(3)==dimB(2) );
  getB=fc_linalg3D.getCpt(B,N);
  
  X=zeros(N,dimA(2),dimB(3));
  for k=1:N
    for l=1:dimB(3)  % Solve A(k,:,:)*x(k,:,l)=b(:,l)
      for i=1:dimA(2)
        S=0;
        for j=1:i-1
          S=S+A(k,i,j)*X(k,j,l);
        end
        X(k,i,l)=(getB(B,k,i,l)-S)/A(k,i,i);
      end
    end
  end
end
